"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const Utils = __importStar(require("../utils"));
const createEncodingMap_1 = require("./createEncodingMap");
/**
 *
 * const encodingMap = {
 *   "application/json": {},
 *   "application/x-www-form-urlencoded": {},
 * }
 */
const createEncodingParams = (factory, params) => {
    var _a;
    const content = (_a = params.operationParams.requestBody) === null || _a === void 0 ? void 0 : _a.content;
    if (!content) {
        return;
    }
    const encodingMap = (0, createEncodingMap_1.createEncodingMap)(content);
    if (Object.keys(encodingMap).length === 0) {
        return;
    }
    if (params.convertedParams.has2OrMoreRequestContentTypes) {
        return factory.Identifier.create({ name: `requestEncodings[params.headers["Content-Type"]]` });
    }
    return factory.Identifier.create({ name: `requestEncodings["${params.convertedParams.requestFirstContentType}"]` });
};
/**
 * this.apiClient.request("GET", url, requestBody, headers, queryParameters);
 */
const create = (factory, params, methodType) => {
    const { convertedParams } = params;
    const apiClientVariableIdentifier = {
        class: "this.apiClient.request",
        function: "apiClient.request",
        "currying-function": "apiClient.request",
    };
    const expression = Utils.generateVariableIdentifier(factory, apiClientVariableIdentifier[methodType]);
    const requestBodyEncoding = createEncodingParams(factory, params);
    const requestArgs = factory.ObjectLiteralExpression.create({
        properties: [
            factory.PropertyAssignment.create({
                name: "httpMethod",
                initializer: factory.StringLiteral.create({ text: params.operationParams.httpMethod.toUpperCase() }),
            }),
            factory.ShorthandPropertyAssignment.create({
                name: methodType === "currying-function" ? "uri" : "url",
            }),
            factory.ShorthandPropertyAssignment.create({
                name: "headers",
            }),
            convertedParams.hasRequestBody &&
                factory.PropertyAssignment.create({
                    name: "requestBody",
                    initializer: Utils.generateVariableIdentifier(factory, "params.requestBody"),
                }),
            requestBodyEncoding &&
                factory.PropertyAssignment.create({
                    name: "requestBodyEncoding",
                    initializer: requestBodyEncoding,
                }),
            convertedParams.hasQueryParameters &&
                factory.PropertyAssignment.create({
                    name: "queryParameters",
                    initializer: factory.Identifier.create({ name: "queryParameters" }),
                }),
        ].flatMap(v => (v ? [v] : [])),
        multiLine: true,
    });
    const argumentsArray = [requestArgs, factory.Identifier.create({ name: "option" })];
    return factory.CallExpression.create({
        expression: expression,
        typeArguments: [],
        argumentsArray: argumentsArray,
    });
};
exports.create = create;
//# sourceMappingURL=CallRequest.js.map