"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateNamespace = void 0;
const Exception_1 = require("../../Exception");
const Guard = __importStar(require("../Guard"));
const Name = __importStar(require("../Name"));
const Header = __importStar(require("./Header"));
const Reference = __importStar(require("./Reference"));
const Schema = __importStar(require("./Schema"));
const generateNamespace = (entryPoint, currentPoint, store, factory, headers, context, converterContext) => {
    store.addComponent("headers", {
        kind: "namespace",
        name: Name.Components.Headers,
    });
    Object.entries(headers).forEach(([name, header]) => {
        if (Guard.isReference(header)) {
            const reference = Reference.generate(entryPoint, currentPoint, header);
            if (reference.type === "local") {
                if (!store.hasStatement(reference.path, ["interface"])) {
                    throw new Exception_1.UndefinedComponent(`Reference "${header.$ref}" did not found in ${reference.path} by ${reference.name}`);
                }
            }
            else if (reference.type === "remote") {
                Schema.addSchema(entryPoint, currentPoint, store, factory, reference.path, reference.name, reference.data.schema, context, converterContext);
            }
        }
        else {
            store.addStatement(`components/headers/${name}`, {
                kind: "typeAlias",
                name: converterContext.escapeDeclarationText(name),
                value: Header.generateTypeNode(entryPoint, currentPoint, factory, name, header, context, converterContext),
            });
        }
    });
};
exports.generateNamespace = generateNamespace;
//# sourceMappingURL=Headers.js.map