"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateInterface = exports.generatePropertySignatures = exports.generatePropertySignature = void 0;
const ToTypeNode = __importStar(require("../toTypeNode"));
const generatePropertySignature = (entryPoint, currentPoint, factory, protocol, schema, context, converterContext) => {
    return factory.PropertySignature.create({
        readOnly: false,
        name: converterContext.escapePropertySignatureName(protocol),
        optional: false,
        type: ToTypeNode.convert(entryPoint, currentPoint, factory, schema, context, converterContext),
        comment: schema.description,
    });
};
exports.generatePropertySignature = generatePropertySignature;
const generatePropertySignatures = (entryPoint, currentPoint, factory, content, context, converterContext) => {
    return Object.entries(content).reduce((previous, [protocol, mediaType]) => {
        if (!mediaType.schema) {
            return previous;
        }
        return previous.concat((0, exports.generatePropertySignature)(entryPoint, currentPoint, factory, protocol, mediaType.schema, context, converterContext));
    }, []);
};
exports.generatePropertySignatures = generatePropertySignatures;
const generateInterface = (entryPoint, currentPoint, factory, name, content, context, converterContext) => {
    return factory.InterfaceDeclaration.create({
        export: true,
        name,
        members: (0, exports.generatePropertySignatures)(entryPoint, currentPoint, factory, content, context, converterContext),
    });
};
exports.generateInterface = generateInterface;
//# sourceMappingURL=MediaType.js.map