"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.make = exports.create = void 0;
const typescript_1 = __importDefault(require("typescript"));
const operators = {
    "+": typescript_1.default.SyntaxKind.PlusToken,
    "=": typescript_1.default.SyntaxKind.EqualsToken,
};
const create = ({ factory }) => (params) => {
    const node = factory.createBinaryExpression(params.left, operators[params.operator], params.right);
    return node;
};
exports.create = create;
const make = (context) => {
    return {
        create: (0, exports.create)(context),
    };
};
exports.make = make;
//# sourceMappingURL=BinaryExpression.js.map