"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.make = exports.create = void 0;
const generateExpression = (factory) => {
    return {
        this: factory.createThis(),
    };
};
const create = ({ factory }) => (params) => {
    let expression = typeof params.expression === "string" ? factory.createIdentifier(params.expression) : params.expression;
    const expressionMap = generateExpression(factory);
    if (typeof params.expression === "string" && params.expression in expressionMap) {
        expression = generateExpression(factory)[params.expression];
    }
    const node = factory.createPropertyAccessExpression(expression, factory.createIdentifier(params.name));
    return node;
};
exports.create = create;
const make = (context) => {
    return {
        create: (0, exports.create)(context),
    };
};
exports.make = make;
//# sourceMappingURL=PropertyAccessExpression.js.map