"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.make = exports.create = void 0;
const typescript_1 = __importDefault(require("typescript"));
const utils_1 = require("./utils");
const create = ({ factory }) => (params) => {
    const node = factory.createPropertySignature(params.readOnly ? [factory.createModifier(typescript_1.default.SyntaxKind.ReadonlyKeyword)] : undefined, params.name, params.optional ? factory.createToken(typescript_1.default.SyntaxKind.QuestionToken) : undefined, params.type);
    if (params.comment) {
        const comment = (0, utils_1.generateComment)(params.comment);
        return typescript_1.default.addSyntheticLeadingComment(node, typescript_1.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
    }
    return node;
};
exports.create = create;
const make = (context) => {
    return {
        create: (0, exports.create)(context),
    };
};
exports.make = make;
//# sourceMappingURL=PropertySignature.js.map