import { TsGenerator } from "../../api";
import * as ApiClientArgument from "../_shared/ApiClientArgument";
import * as ApiClientClass from "./ApiClientClass";
export const generator = (codeGeneratorParamsList, option) => {
    const statements = [];
    const factory = TsGenerator.Factory.create();
    codeGeneratorParamsList.forEach(codeGeneratorParams => {
        const { convertedParams } = codeGeneratorParams;
        if (convertedParams.hasRequestBody) {
            statements.push(ApiClientArgument.createRequestContentTypeReference(factory, codeGeneratorParams));
        }
        if (convertedParams.responseSuccessNames.length > 0) {
            statements.push(ApiClientArgument.createResponseContentTypeReference(factory, codeGeneratorParams));
        }
        const typeDeclaration = ApiClientArgument.create(factory, codeGeneratorParams);
        if (typeDeclaration) {
            statements.push(typeDeclaration);
        }
    });
    ApiClientClass.create(factory, codeGeneratorParamsList, option || {}).forEach(newStatement => {
        statements.push(newStatement);
    });
    return statements;
};
//# sourceMappingURL=index.js.map