import { TsGenerator } from "../../api";
import * as ApiClientArgument from "../_shared/ApiClientArgument";
import * as FunctionalApiClient from "./FunctionalApiClient";
import * as ApiClientInterface from "../_shared/ApiClientInterface";
export const generator = (codeGeneratorParamsList, option) => {
    const statements = [];
    const factory = TsGenerator.Factory.create();
    codeGeneratorParamsList.forEach(codeGeneratorParams => {
        const { convertedParams } = codeGeneratorParams;
        if (convertedParams.hasRequestBody) {
            statements.push(ApiClientArgument.createRequestContentTypeReference(factory, codeGeneratorParams));
        }
        if (convertedParams.responseSuccessNames.length > 0) {
            statements.push(ApiClientArgument.createResponseContentTypeReference(factory, codeGeneratorParams));
        }
        const typeDeclaration = ApiClientArgument.create(factory, codeGeneratorParams);
        if (typeDeclaration) {
            statements.push(typeDeclaration);
        }
    });
    ApiClientInterface.create(factory, codeGeneratorParamsList, "currying-function", option || {}).forEach(statement => {
        statements.push(statement);
    });
    const apiClientStatements = FunctionalApiClient.create(factory, codeGeneratorParamsList, option || {});
    apiClientStatements.forEach(apiClientStatement => {
        statements.push(apiClientStatement);
    });
    return statements;
};
//# sourceMappingURL=index.js.map