import * as path from "path";
import * as Guard from "../Guard";
import * as Name from "../Name";
import * as Reference from "./Reference";
import * as RequestBody from "./RequestBody";
export const generateNamespace = (entryPoint, currentPoint, store, factory, requestBodies, context, converterContext) => {
    const basePath = "components/requestBodies";
    store.addComponent("requestBodies", {
        kind: "namespace",
        name: Name.Components.RequestBodies,
    });
    Object.entries(requestBodies).forEach(([name, requestBody]) => {
        if (Guard.isReference(requestBody)) {
            const reference = Reference.generate(entryPoint, currentPoint, requestBody);
            if (reference.type === "local") {
                throw new Error("not support");
            }
            else if (reference.type === "remote") {
                RequestBody.generateNamespace(entryPoint, reference.referencePoint, store, factory, path.dirname(reference.path), reference.name, reference.data, context, converterContext);
            }
        }
        else {
            RequestBody.generateNamespace(entryPoint, currentPoint, store, factory, basePath, name, requestBody, context, converterContext);
        }
    });
};
//# sourceMappingURL=RequestBodies.js.map