export const parameterName = (operationId) => `Parameter$${operationId}`;
export const requestBodyName = (operationId) => `RequestBody$${operationId}`;
export const argumentParamsTypeDeclaration = (operationId) => `Params$${operationId}`;
export const responseName = (operationId, statusCode) => `Response$${operationId}$Status$${statusCode}`;
export const requestContentType = (operationId) => `RequestContentType$${operationId}`;
export const responseContentType = (operationId) => `ResponseContentType$${operationId}`;
export const isAvailableVariableName = (text) => {
    return /^[A-Za-z_0-9\s]+$/.test(text);
};
export const isFirstCharacterIsValidText = (text) => {
    return /^[A-Za-z]+/.test(text);
};
export const escapeText = (text) => {
    if (isAvailableVariableName(text) && isFirstCharacterIsValidText(text)) {
        return text;
    }
    return `"${text}"`;
};
/** TODO escapeTextにマージする */
export const escapeText2 = (text) => {
    if (isAvailableVariableName(text)) {
        return {
            escaped: false,
            text: text,
        };
    }
    return {
        escaped: true,
        text: `"${text}"`,
    };
};
//# sourceMappingURL=utils.js.map