import ts from "typescript";
import type { OpenApi } from "../../types";
import { Factory } from "../TsGenerator";
import * as Reference from "./components/Reference";
import * as ConverterContext from "./ConverterContext";
import { ObjectSchemaWithAdditionalProperties } from "./types";
export interface ResolveReferencePath {
    name: string;
    maybeResolvedName: string;
    unresolvedPaths: string[];
    /**
     * @example components.a.b.c.dの場合 ["a", "b", "c", "d"].length = 4
     **/
    depth: number;
    /**
     * Input $ref divided by / (except #)
     */
    pathArray: string[];
}
export interface Context {
    readonly rootSchema: OpenApi.Document;
    setReferenceHandler: (currentPoint: string, reference: Reference.Type<OpenApi.Schema | OpenApi.JSONSchemaDefinition>) => void;
    resolveReferencePath: (currentPoint: string, referencePath: string) => ResolveReferencePath;
    findSchemaByPathArray: (paths: string[]) => OpenApi.Schema | OpenApi.Reference | OpenApi.JSONSchemaDefinition;
}
export type Convert = (entryPoint: string, currentPoint: string, factory: Factory.Type, schema: OpenApi.Schema | OpenApi.Reference | OpenApi.JSONSchemaDefinition, setReference: Context, convertContext: ConverterContext.Types, option?: Option) => ts.TypeNode;
export interface Option {
    parent?: any;
}
export declare const generateMultiTypeNode: (entryPoint: string, currentPoint: string, factory: Factory.Type, schemas: OpenApi.JSONSchema[], setReference: Context, convert: Convert, convertContext: ConverterContext.Types, multiType: "oneOf" | "allOf" | "anyOf") => ts.TypeNode;
export declare const convert: Convert;
export declare const convertAdditionalProperties: (entryPoint: string, currentPoint: string, factory: Factory.Type, schema: ObjectSchemaWithAdditionalProperties, setReference: Context, convertContext: ConverterContext.Types) => ts.IndexSignatureDeclaration;
